<?php
require_once("3rdparty/hosting/AControlPanel.php");

class hostingclass extends AControlPanel{

	public $Error;
	public $Warning;
	public $Success;

	function __construct(){
		$this->Error = array();
		$this->Warning = array();
		$this->Success = array();
	}

	function validateLogin()
	{
		// Check login credentials
		$login_valid = true;

		if($login_valid === true)
		{
			return true;
		}

		$this->Error[] = 'Error message, if possible with reason why validation failed';
		return false;
	}


	function getPackage($packagename, $reseller = false)
	{
		// After getting the limits from the server, define variables
		$this->Package_BandWidth = 2000;
		$this->Package_DiscSpace = 50;
		$this->Package_Domains = 0;
		$this->Package_SubDomains = 0;
		$this->Package_Domainpointers = 0;
		$this->Package_EmailAccounts = 25;
		$this->Package_MySQLDatabases = 2;

		// We have unlimited domains, subdomains and pointers
		$this->Package_uDomains = 1;
		$this->Package_uSubDomains = 1;
		$this->Package_uDomainpointers = 1;

		return true;
	}

	function listPackages()
	{
		$packages = array('user' => array(), 'reseller' => array());

		// Get account packages and put them in array.
		$packages['user'][] = 'Package_A';
		$packages['user'][] = 'Package_B';

		// Get reseller packages and put them in array.
		$packages['reseller'][] = 'Reseller package 1';

		return $packages;
	}


	function createAccount()
	{
		// Create account on server
		$result = true;

		if($result)
		{
			return true;
		}
		else
		{
			// Give reason of error
			$this->Error[] = 'Your error message';

			// Log the message if cronjob runs this action
			createMessageLog('error','Your error message for logging');
			return false;
		}
	}

	function createResellerAccount()
	{
		// Create reseller account on server
		$result = true;

		if($result)
		{
			return true;
		}
		else
		{
			// Give reason of error
			$this->Error[] = 'Your error message';

			// Log the message if cronjob runs this action
			createMessageLog('error','Your error message for logging');
			return false;
		}
	}

	function deleteAccount()
	{
		// Delete account on server
		$result = true;

		if($result)
		{
			return true;
		}
		else
		{
			// Give reason of error
			$this->Error[] = 'Your error message';

			// Log the message if cronjob runs this action
			createMessageLog('error','Your error message for logging');
			return false;
		}
	}

	function checkIfAccountExists()
	{
		// Check if account exists on the server
		$result = true;

		if($result)
		{
			return true;
		}
		else
		{
			// Give reason of error
			$this->Error[] = 'Your error message';
			return false;
		}
	}

	function getAccountUsage($accountname)
	{
		// Get account usage and limits for bandwidth and webspace
		$usage = array();

		// Only fill array if we retrieved data
		if(true)
		{
			// Real usage in MBs
			$usage['UsedBandWidth'] = 1253;
			$usage['UsedDiscSpace'] = 25.5;

			// Limits in MBs
			$usage['BandWidth'] = 2000;
			$usage['DiscSpace'] = 30;
		}

		return $usage;
	}

	function listAccounts()
	{
		$account_list = array();

		// Loop through retrieved accounts
		foreach($retrieved_accounts as $acc_info)
		{
			$account = array();

			$account['Username'] 	= $acc_info['Username'];
			$account['Password'] 	= ''; // unknown
			$account['Type']	 	= 'normal';
			$account['Domain'] 		= $acc_info['Domain'];
			$account['Package'] 	= $acc_info['Package'];
			$account['Suspended'] 	= ($acc_info['Status'] != 'active') ? 'yes' : 'no';

			$account_list[] = $account;
		}

		return $account_list;
	}

	function suspendAccount()
	{
		// Suspend user
		$suspended = true;

		if($suspended)
		{
			return true;
		}
		else
		{
			$this->Error[] = '(un)suspending failed';
			return false;
		}
	}

	function changeAccountPassword()
	{
		// Change the password of the hosting account (and FTP, MYSQL, email root account) on the server
		$result = true;

		if($result)
		{
			return true;
		}
		else
		{
			// Give reason of error
			$this->Error[] = 'Your error message';

			createMessageLog('error','Your error message for logging');
			return false;
		}
	}

	function changePackage($Username, $TemplateName)
	{
		// Change the package of the hosting account on the server
		$result = true;

		if($result)
		{
			return true;
		}
		else
		{
			// Give reason of error
			$this->Error[] = 'Your error message';

			createMessageLog('error','Your error message for logging');
			return false;
		}
	}

	function addDomain()
	{

		// Switch between different domain types
		switch($this->DomainType){
			default:
			case 'alias':
			case 'pointer':
			case 'additional':

				// Add domain to hosting account
				$result = true;

			break;
		}

		if($result)
		{
			return true;
		}
		else
		{
			// Give reason of error
			$this->Error[] = 'Your error message';

			// Log the message if cronjob runs this action
			createMessageLog('error','Your error message for logging');
			return false;
		}
	}

	function listDomains($accountname)
	{
		$domains = array();

		// Get domains and fill array

		$domain_array['hostfact.com'] = array("Domain" => 'hostfact.com',
											"BandWidth" => "123.43 MB",
											"DiscSpace" => "12.4 MB",
											"Active" => true); // Tells HostFact the domain is active on the server.



		return $domains;
	}

	function createDNSZone($domain, $dns_zone) {
		/**
		 * Step 1) check if DNS zone exists on server
		 */
		$response 	= true;

		/**
		 * Step 2a) DNS zone exists, update DNS zone
		 */
		if($response === true)
		{
			return $this->saveDNSZone($domain, $dns_zone);
		}

		/**
		 * Step 2b) DNS zone does not exist, create a new one
		 */
		$create_response 	= true;

		/**
		 * Step 3) provide feedback to HostFact
		 */
		if($create_response === true)
		{
			return TRUE;
		}
		else
		{
			// failed
			return FALSE;
		}
	}

	function getDNSZone($domain) {
		/**
		 * Step 1) get DNS zone
		 */
		$response 	= true;

		/**
		 * Step 2) provide feedback to HostFact
		 */
		if($response === true)
		{
			$i = 0;
			$dns_zone = array();

			foreach($response['records'] as $record)
			{
				// optionally, you can define records as readonly, these records won't be editable in HostFact
				if(strtolower($record['type']) == 'soa')
				{
					$record_type = 'records_readonly';
				}
				else
				{
					$record_type = 'records';
				}

				$dns_zone[$record_type][$i]['name']        = $record['name'];
				$dns_zone[$record_type][$i]['type']        = $record['type'];
				$dns_zone[$record_type][$i]['value']       = $record['value'];
				$dns_zone[$record_type][$i]['priority']    = $record['prio'];
				$dns_zone[$record_type][$i]['ttl']         = $record['ttl'];
				$dns_zone[$record_type][$i]['id']          = $record['id']; // not required

				$i++;
			}

			return $dns_zone;
		}
		else
		{
			// DNS zone does not exist or API call failed
			return FALSE;
		}
	}

	function saveDNSZone($domain, $dns_zone) {

		/*
		if the control panel does not support a update command, but only add/delete commands
		use the getDNSZone command and compare it's output with the $dns_zone array
		this way you can check which records are edited and add/delete them accordingly
		*/

		/**
		 * Step 1) update DNS zone at server
		 */
		$response 	= true;

		/**
		 * Step 2) provide feedback to HostFact
		 */
		if($response === true)
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}

	function singleSignOn()
	{
		// Get a redirect URL OR return some data for posting a form.
		$result = TRUE;
		$method = 'url'; // 'url' or 'post'. Option must be set in version.php. Here it is done for this example.

		// Use a URL redirect
		if($result && $method == 'url')
		{
			return array('url' => 'https://url/?session_token=XYZ');
		}
		// Use form post
		elseif($result && $method == 'post')
		{
			// Build result array with form_action and post data
			$result = array();
			$result['form_action'] = 'https://url/';
			$result['data']['username'] = $this->Username;
			$result['data']['password'] = 'temp-password';

			return $result;
		}
		else
		{
			// Give reason of error
			$this->Error[] = 'Your error message';

			createMessageLog('error', 'Your error message for logging');

			return FALSE;
		}
	}

}
